unit ktSColDg; {v2.01	 08/20/1998	for	Delphi 1,	2, 3 and 4 now}
				{it	replaces ktSysColorDialog.pas	up to	version	1.1,
				the	componentname	is unchanged.	}

{
I	have a favor to	ask	these	testers	of my	component	which	still	have the
possibility	to work	with a non-english version of	Windows	3.xx:
Please check the control.ini and tell	me if	the	custom colors	are	stored there
in the following format:

[Custom	Colors]
ColorA=
..
ColorP=				 that	means	in English in	non-english	versions too

Any	help will	be very	appreciated.
Thanks in	advance.

Kerstin	Thaler
email: muk.thaler@t-online.de
}

interface

uses
{$IFNDEF VER80}
	Windows,
{$ELSE}
	WinTypes,	WinProcs,
{$ENDIF}
	Messages,	SysUtils,	Classes, Graphics, Controls, Forms,	Dialogs, Consts;

{$IFDEF	VER100}
	{$DEFINE D2_UP}
{$ENDIF}

{$IFDEF	VER120}
	{$DEFINE D2_UP}
{$ENDIF}

const
{$IFNDEF VER80}
	SysColorKey	=	'Control Panel\Appearance';
{$ELSE}
	SysColorKey	=	'Custom	Colors';
	SysColorIni	=	'Control.ini';
{$ENDIF}

type
{$IFNDEF VER80}
	PColorArray	=	^TColorArray;
	{$IFNDEF VER120}
		TColorArray	=	array[0..High(Cardinal)	div	SizeOf(TColorref)	-	1] of	TColorref;
	{$ELSE}
		TColorArray	=	array[0..High(Longint) div SizeOf(TColorref) - 1]	of TColorref;
	{$ENDIF}
{$ENDIF}

	TktSysColorDialog	 = class(TColorDialog)
	private
	{	Private-Deklarationen	}
		FColorKey: string;
		FUseSysColors: Boolean;
		ColorPrefix, ColorTags:	string;
{$IFDEF	VER80}
		FIni:	string;
		procedure	SetIni(Value:	string);
{$ENDIF}
		procedure	SetColorKey(Value: string);
		procedure	SetUseSysColors(Value: Boolean);
	protected
	{	Protected-Deklarationen	}
{$IFDEF	VER80}
		procedure	LoadColorsFromIni;
		procedure	SaveColorsToIni;
{$ELSE}
		procedure	LoadColorsFromReg;
		procedure	SaveColorsToReg;
{$ENDIF}
	public
	{	Public-Deklarationen }
		constructor	Create(AOwner: TComponent);	override;
		destructor Destroy;	override;
		function Execute:	Boolean;{$IFDEF	D2_UP}override;
{$ENDIF}
	published
	{	Published-Deklarationen	}
{$IFDEF	VER80}
		property Ini:	string read	FIni write SetIni;
{$ENDIF}
		property ColorKey: string	read FColorKey write SetColorKey;
		property UseSysColors: Boolean read	FUseSysColors	write	SetUseSysColors
			default	TRUE;
	end;

	procedure	Register;

implementation

uses
{$IFDEF	VER80}
	IniFiles;
{$ELSE}
	Registry;
{$ENDIF}

procedure	Register;
begin
	RegisterComponents('Dialoge',	[TktSysColorDialog]);
end;

function HexToInt(s: string):	Longint;
begin
	Result :=	StrToInt('$' + s);
end;

constructor	TktSysColorDialog.Create(AOwner: TComponent);
var
	i: Integer;
begin
{$IFDEF	D2_UP}
	ColorPrefix	:= SColorPrefix;
	ColorTags	:= SColorTags;
{$ELSE}
	ColorPrefix	:= LoadStr(SColorPrefix);
	ColorTags	:= LoadStr(SColorTags);
{$ENDIF}
	inherited	Create(AOwner);
	UseSysColors :=	TRUE;
	for	i	:= 1 to	16 do
		CustomColors.Add(ColorPrefix + ColorTags[i]	+	'=FFFFFF');
end;

destructor TktSysColorDialog.Destroy;
begin
	inherited	Destroy;
end;

procedure	TktSysColorDialog.SetColorKey(Value: string);
begin
	if Value <>	FColorKey	then
		FColorKey	:= Value;
end;

procedure	TktSysColorDialog.SetUseSysColors(Value: Boolean);
begin
	if Value <>	FUseSysColors	then
		FUseSysColors	:= Value;
	if FUseSysColors then
	begin
		SetColorKey(SysColorKey);
{$IFDEF	VER80}
		SetIni(SysColorIni);
{$ENDIF}
	end;
end;

{$IFDEF	VER80}

procedure	TktSysColorDialog.SetIni(Value:	string);
begin
	if Value <>	FIni then
		FIni :=	Value;
end;

procedure	TktSysColorDialog.LoadColorsFromIni;
var
	i: Integer;
	s: string;
	ColorList: TStringList;
	ColorIni:	TIniFile;
begin
	ColorIni :=	TIniFile.Create(FIni);
	ColorList	:= TStringList.Create;
	try
		ColorIni.ReadSection(FColorKey,	ColorList);
		if ColorList.Count > 0 then
		begin
			CustomColors.Clear;
			for	i	:= 0 to	15 do
			begin
				s	:= ColorIni.ReadString(FColorKey,	'Color'	+	chr(65 + i), 'FFFFFF');
				CustomColors.Add(ColorPrefix + chr(65	+	i) + '=' + s);
			end;
		end;
	finally
		ColorIni.Free;
		ColorList.Free;
	end;
end;

procedure	TktSysColorDialog.SaveColorsToIni;
var
	i: Integer;
	s: string;
	ColorIni:	TIniFile;
begin
	ColorIni :=	TIniFile.Create(FIni);
	with ColorIni	do
		try
		EraseSection(FColorKey);
		for	i	:= 0 to	15 do
		begin
			s	:= CustomColors.Strings[i];
			s	:= Copy(s, Pos('=',	s) + 1,	Length(s));
			WriteString(FColorKey, 'Color' + chr(65	+	i),	s);
		end;
	finally
		ColorIni.Free;
	end;
end;

{$ELSE}

procedure	TktSysColorDialog.LoadColorsFromReg;
var
	numEntries,	DataSize,	i: Integer;
	Reg: TRegistry;
	ColorArray:	PColorArray;
begin
	Reg	:= TRegistry.Create;
	with Reg do
	try
		RootKey	:= HKEY_CURRENT_USER;
		DataSize :=	0;
		if OpenKey(FColorKey,	FALSE) then
		begin
			if ValueExists('CustomColors') then
			begin
				DataSize :=	GetDataSize('CustomColors');
				CustomColors.Clear;
			end;
			if DataSize	>	0	then
			begin
				ColorArray :=	AllocMem(DataSize);
				try
					numEntries :=	DataSize div SizeOf(TColorref);
					ReadBinaryData('CustomColors', ColorArray^,	DataSize);
					for	i	:= 0 to	numEntries - 1 do
						CustomColors.Add(ColorPrefix + chr(65	+	i) + '=' + IntToHex(ColorArray^[i],	6));
				finally
					FreeMem(ColorArray);
				end;
			end;
		end;
	finally
		CloseKey;
		Free;
	end;
end;

procedure	TktSysColorDialog.SaveColorsToReg;
var
	numEntries,	DataSize,	i: Integer;
	s: string;
	Reg: TRegistry;
	ColorArray:	PColorArray;
begin
	Reg	 :=	TRegistry.Create;
	with Reg do
	try
		RootKey	:= HKEY_CURRENT_USER;
		if OpenKey(FColorKey,	TRUE)	then
		begin
			if ValueExists('CustomColors') then
				DataSize :=	GetDataSize('CustomColors')
			else
				DataSize :=	64;
			if DataSize	>	0	then
			begin
				ColorArray :=	AllocMem(DataSize);
				try
					numEntries :=	DataSize div SizeOf(TColorref);
					for	i	:= 0 to	numEntries - 1 do
					begin
						s	:= CustomColors.Strings[i];
						s	:= Copy(s, Pos('=',	s) + 1,	Length(s));
						ColorArray^[i] :=	HexToInt(s);
					end;
					WriteBinaryData('CustomColors',	ColorArray^, DataSize);
				finally
					FreeMem(ColorArray);
				end;
			end;
		end;
	finally
		CloseKey;
		Free;
	end;
end;

{$ENDIF}

function TktSysColorDialog.Execute;
begin
{$IFDEF	VER80}
	LoadColorsFromIni;
{$ELSE}
	LoadColorsFromReg;
{$ENDIF}
	Result :=	inherited	Execute;
{$IFDEF	VER80}
	if Result	then SaveColorsToIni;
{$ELSE}
	if Result	then SaveColorsToReg;
{$ENDIF}
end;

end.

